<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'weixin';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'menu';

// 载入并实例化类库
require (ROOT_PATH . 'include/weixin/core.class.php');
require (ROOT_PATH . 'include/weixin/weixin.class.php');

$weixin = new Weixin($_PARAM['weixin_appid'], $_PARAM['weixin_appsecret']);

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 系统设置
 * +----------------------------------------------------------
 */
if ($rec == 'system') {
    $smarty->assign('ur_here', $_LANG['weixin_system']);
    
    // act操作项的初始化
    $act = $check->is_rec($_REQUEST['act']) ? $_REQUEST['act'] : 'default';
    
    // 系统设置
    if ($act == 'default') {
        // 配置项如果不存在，则先写入
        $set_list = array('weixin_appid', 'weixin_appsecret', 'weixin_apptoken');
        foreach ($set_list as $name) {
            if (!$dou->value_exist('parameter', 'name', $name)) {
                $dou->query("INSERT INTO " . $dou->table('parameter') . " (id, name, lang, value, cue, `group`)" . " VALUES (NULL, '$name', '" . $_LANG['weixin_' . $name . '_lang'] . "', '" . $_LANG['weixin_' . $name . '_value'] . "', '" . $_LANG['weixin_' . $name . '_cue'] . "', 'weixin')");
            }
        }
        
        // 读取配置项
        $sql = "SELECT * FROM " . $dou->table('parameter') . $where . " WHERE `group` = 'weixin' ORDER BY `group` DESC, sort ASC, id ASC";
        $query = $dou->query($sql);
        while ($row = $dou->fetch_array($query)) {
            $parameter_list[] = array (
                    "id" => $row['id'],
                    "name" => $row['name'],
                    "lang" => $row['lang'],
                    "value" => $row['value'],
                    "cue" => $row['cue']
            );
        }
        
        // CSRF防御令牌生成
        $smarty->assign('token', $token = $firewall->get_token());
        
        $smarty->assign('parameter_list', $parameter_list);
        $smarty->display('weixin.htm');
    }    

    // 系统设置数据更新
    elseif ($act == 'update') {
        // CSRF防御令牌验证
        $firewall->check_token($_POST['token']);
        
        foreach ($_POST as $name => $value) {
            $dou->query("UPDATE " . $dou->table('parameter') . " SET value = '$value' WHERE name = '$name'");
        }
        
        $dou->create_admin_log($_LANG['weixin'] . ' - ' . $_LANG['weixin_system'] . ': ' . $_LANG['edit_succes']);
        $dou->dou_msg($_LANG['edit_succes'], 'weixin.php?rec=system');
    }
} 

/**
 * +----------------------------------------------------------
 * 自定义菜单
 * +----------------------------------------------------------
 */
elseif ($rec == 'menu') {
    // act操作项的初始化
    $act = $check->is_rec($_REQUEST['act']) ? $_REQUEST['act'] : 'default';
    
    // 赋值给模板
    $smarty->assign('act', $act);
    
    // 幻灯列表
    if ($act == 'default') {
        $smarty->assign('ur_here', $_LANG['weixin_menu']);
        $smarty->assign('action_link', array (
                'text' => $_LANG['weixin_menu_add'],
                'href' => 'weixin.php?rec=menu&act=add' 
        ));
        
        // 赋值给模板
        $smarty->assign('form_action', 'insert');
        $smarty->assign('menu_list', $weixin->get_menu_list());
        
        $smarty->display('weixin.htm');
    }

    // 菜单添加
    elseif ($act == 'add') {
        $smarty->assign('ur_here', $_LANG['weixin_menu_add']);
        $smarty->assign('action_link', array (
                'text' => $_LANG['weixin_menu'],
                'href' => 'weixin.php?rec=menu' 
        ));
     
        // CSRF防御令牌生成
        $smarty->assign('token', $token = $firewall->get_token());
        
        // 赋值给模板
        $smarty->assign('form_action', 'insert');
        $smarty->assign('menu_list', $weixin->get_menu_list());
        $smarty->assign('media_list', $weixin->get_media_list());
        
        $smarty->display('weixin.htm');
    }

    // 菜单添加处理
    elseif ($act == 'insert') {
        if (empty($_POST['name']))
            $dou->dou_msg($_LANG['weixin_menu_name'] . $_LANG['is_empty']);
     
        // 格式化
        if ($_POST['type'] == 'media') {
            $code = array (
                    "type" => 'click',
                    "name" => $_POST['name'],
                    "key" => $_POST['media']
            );
        } elseif ($_POST['type'] == 'url') {
            $code = array (
                    "type" => 'view',
                    "name" => $_POST['name'],
                    "url" => $_POST['url']
            );
        }
        $code = serialize($code);
            
        // CSRF防御令牌验证
        $firewall->check_token($_POST['token']);
        
        $sql = "INSERT INTO " . $dou->table('weixin_menu') . " (id, name, code, parent_id, sort)" . " VALUES (NULL, '$_POST[name]', '$code', '$_POST[parent_id]', '$_POST[sort]')";
        $dou->query($sql);
        
        $dou->create_admin_log($_LANG['weixin'] . ' - ' . $_LANG['weixin_menu_add'] . ': ' . $_POST['name']);
        $dou->dou_msg($_LANG['weixin_menu_add'] . $_LANG['success'], 'weixin.php?rec=menu');
    }

    // 菜单编辑
    elseif ($act == 'edit') {
        $smarty->assign('ur_here', $_LANG['weixin_menu_eidt']);
        $smarty->assign('action_link', array (
                'text' => $_LANG['weixin_menu'],
                'href' => 'weixin.php?rec=menu' 
        ));
        
        // 验证并获取合法的ID
        $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
        
        $menu = $dou->get_row('weixin_menu', '*', "id = '$id'");
     
        // 格式化
        $menu['code'] = unserialize($menu['code']);
        if (isset($menu['code']['url'])) {
            $menu['type'] = isset($menu['code']['url']) ? 'url' : 'media';
        }
        
        // CSRF防御令牌生成
        $smarty->assign('token', $token = $firewall->get_token());
        
        // 赋值给模板
        $smarty->assign('form_action', 'update');
        $smarty->assign('menu_list', $weixin->get_menu_list($menu['parent_id']));
        $smarty->assign('media_list', $weixin->get_media_list($menu['code']['key']));
        $smarty->assign('menu', $menu);
        
        $smarty->display('weixin.htm');
    }

    // 菜单编辑处理
    elseif ($act == 'update') {
        // 验证并获取合法的ID
        $id = $check->is_number($_POST['id']) ? $_POST['id'] : '';
     
        if (empty($_POST['name']))
            $dou->dou_msg($_LANG['weixin_menu_name'] . $_LANG['is_empty']);
     
        // 格式化
        if ($_POST['type'] == 'media') {
            $code = array (
                    "type" => 'click',
                    "name" => $_POST['name'],
                    "key" => $_POST['media']
            );
        } elseif ($_POST['type'] == 'url') {
            $code = array (
                    "type" => 'view',
                    "name" => $_POST['name'],
                    "url" => $_POST['url']
            );
        }
        $code = serialize($code);
            
        // CSRF防御令牌验证
        $firewall->check_token($_POST['token']);
        
        $sql = "UPDATE " . $dou->table('weixin_menu') . " SET name = '$_POST[name]', code = '$code', parent_id = '$_POST[parent_id]', sort = '$_POST[sort]' WHERE id = '$id'";
        $dou->query($sql);
        
        $dou->create_admin_log($_LANG['weixin'] . ' - ' . $_LANG['weixin_menu_edit'] . ': ' . $_POST['name']);
        $dou->dou_msg($_LANG['weixin_menu_edit_succes'], 'weixin.php?rec=menu');
    } 

    // 菜单删除
    elseif ($act == 'del') {
        // 验证并获取合法的ID
        $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'weixin.php?rec=menu');
        
        $name = $dou->get_one("SELECT name FROM " . $dou->table('weixin_menu') . " WHERE id = '$id'");
        
        if (isset($_POST['confirm'])) {
            $dou->create_admin_log($_LANG['weixin'] . ' - ' . $_LANG['weixin_menu_del'] . ': ' . $name);
            $dou->delete('weixin_menu', "id = '$id'", 'weixin.php?rec=menu');
        } else {
            $_LANG['del_check'] = preg_replace('/d%/Ums', $name, $_LANG['del_check']);
            $dou->dou_msg($_LANG['del_check'], 'weixin.php?rec=menu', '', '30', "weixin.php?rec=menu&act=del&id=$id");
        }
    }
 
    // 推送到公众号
    elseif ($act == 'push') {
        $menu_list['button'] = $weixin->get_menu_weixin_data();
        if ($weixin->menuSet($menu_list)) {
            $dou->dou_msg($_LANG['weixin_menu_push_success'], 'weixin.php?rec=menu');
        } else {
            $dou->dou_msg($_LANG['weixin_menu_push_wrong'], 'weixin.php?rec=menu');
        }
    }
 
    // 从公众号提取
    elseif ($act == 'get') {
        if ($menu_weixin = $weixin->menuGet()) {
            // 先清空本地菜单表
            $dou->query("TRUNCATE " . $dou->table('weixin_menu'));
            
            // 再将从公众号提取的菜单写入数据库
            foreach ((array)$menu_weixin as $menu) { // 遍历一级目录
                $code = $menu;
                unset($code['sub_button']);
                $code = serialize($code);
                $dou->query("INSERT INTO " . $dou->table('weixin_menu') . " (id, name, code, sort)" . " VALUES (NULL, '$menu[name]', '$code', '50')");
                
                $parent_id = $dou->insert_id();
                foreach ((array)$menu['sub_button'] as $sub) {
                    $code_sub = serialize($sub);
                    $dou->query("INSERT INTO " . $dou->table('weixin_menu') . " (id, name, code, parent_id, sort)" . " VALUES (NULL, '$sub[name]', '$code_sub', '$parent_id', '50')");
                }
            }
            $dou->dou_msg($_LANG['weixin_menu_get_success'], 'weixin.php?rec=menu');
        } else {
            $dou->dou_msg($_LANG['weixin_menu_get_wrong'], 'weixin.php?rec=menu');
        }
    }
 
    // 文章列表.HTML
    elseif ($act == 'article_html') {
        // 验证并获取合法的ID
        $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
        
        echo $weixin->get_article_html($page);
    }
}

/**
 * +----------------------------------------------------------
 * 素材管理
 * +----------------------------------------------------------
 */
elseif ($rec == 'media') {
    // act操作项的初始化
    $act = $check->is_rec($_REQUEST['act']) ? $_REQUEST['act'] : 'default';
    
    // 赋值给模板
    $smarty->assign('act', $act);
    
    // 素材列表
    if ($act == 'default') {
        $smarty->assign('ur_here', $_LANG['weixin_media']);
        $smarty->assign('action_link', array (
                'text' => $_LANG['weixin_media_add'],
                'href' => 'weixin.php?rec=media&act=add' 
        ));
     
        // 未加入分页条件的SQL语句
        $sql = "SELECT * FROM " . $dou->table('weixin_media') . " ORDER BY id DESC";
 
        // 分页
        $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
        $limit = $dou->pager($sql, 15, $page, 'weixin.php?rec=media');

        $sql = $sql . $limit; // 加入分页条件的SQL语句
        $query = $dou->query($sql);
        while ($row = $dou->fetch_array($query)) {
            $add_time = date("Y-m-d", $row['add_time']);

            $media_list[] = array (
                    "id" => $row['id'],
                    "name" => $row['name'],
                    "article_list" => $weixin->article_selected(unserialize($row['article_list'])),
                    "type" => $row['type'],
                    "add_time" => $add_time 
            );
        }
        
        // 赋值给模板
        $smarty->assign('page', $page);
        $smarty->assign('media_list', $media_list);
        $smarty->display('weixin.htm');
    }

    // 素材添加
    elseif ($act == 'add') {
        $smarty->assign('ur_here', $_LANG['weixin_media_add']);
        $smarty->assign('action_link', array (
                'text' => $_LANG['weixin_media_list'],
                'href' => 'weixin.php?rec=media' 
        ));
     
        // 清空已选文章
        unset($_SESSION[DOU_ID]['article_selected']);
     
        // CSRF防御令牌生成
        $smarty->assign('token', $token = $firewall->get_token());
        
        // 赋值给模板
        $smarty->assign('form_action', 'insert');
        $smarty->assign('article_can_select_html', $weixin->article_can_select_html());
        
        $smarty->display('weixin.htm');
    }

    // 素材添加处理
    elseif ($act == 'insert') {
        if (empty($_POST['name']))
            $dou->dou_msg($_LANG['weixin_media_name'] . $_LANG['is_empty']);
        
        if (!$_SESSION[DOU_ID]['article_selected'])
            $dou->dou_msg($_LANG['weixin_media_article_list_wrong']);
     
        // 格式化数据
        $article_list = serialize($_SESSION[DOU_ID]['article_selected']);
        $add_time = time();
        
        // CSRF防御令牌验证
        $firewall->check_token($_POST['token']);
        
        $sql = "INSERT INTO " . $dou->table('weixin_media') . " (id, name, article_list, add_time)" . " VALUES (NULL, '$_POST[name]', '$article_list', '$add_time')";
        $dou->query($sql);
     
        // 清空已选文章
        unset($_SESSION[DOU_ID]['article_selected']);
        
        $dou->create_admin_log($_LANG['weixin'] . ' - ' . $_LANG['weixin_media_add'] . ': ' . $_POST['name']);
        $dou->dou_msg($_LANG['weixin_media_add'] . $_LANG['success'], 'weixin.php?rec=media');
    }

    // 素材编辑
    elseif ($act == 'edit') {
        $smarty->assign('ur_here', $_LANG['weixin_media_eidt']);
        $smarty->assign('action_link', array (
                'text' => $_LANG['weixin_media_list'],
                'href' => 'weixin.php?rec=media' 
        ));
       
        // 验证并获取合法的ID
        $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
        
        $media = $dou->get_row('weixin_media', '*', "id = '$id'");
     
        // 是否第一次添加
        $_SESSION[DOU_ID]['article_selected'] = unserialize($media['article_list']);
        
        // CSRF防御令牌生成
        $smarty->assign('token', $token = $firewall->get_token());
        
        // 赋值给模板
        $smarty->assign('form_action', 'update');
        $smarty->assign('article_selected_html', $weixin->article_selected_html());
        $smarty->assign('article_can_select_html', $weixin->article_can_select_html());
        $smarty->assign('media', $media);
        
        $smarty->display('weixin.htm');
    }

    // 素材编辑处理
    elseif ($act == 'update') {
        // 验证并获取合法的ID
        $id = $check->is_number($_POST['id']) ? $_POST['id'] : '';
     
        if (empty($_POST['name']))
            $dou->dou_msg($_LANG['weixin_media_name'] . $_LANG['is_empty']);
        
        if (!$_SESSION[DOU_ID]['article_selected'])
            $dou->dou_msg($_LANG['weixin_media_article_list_wrong']);
     
        // 格式化数据
        $article_list = serialize($_SESSION[DOU_ID]['article_selected']);
            
        // CSRF防御令牌验证
        $firewall->check_token($_POST['token']);
        
        $sql = "UPDATE " . $dou->table('weixin_media') . " SET name = '$_POST[name]', article_list = '$article_list' WHERE id = '$id'";
        $dou->query($sql);
     
        // 清空已选文章
        unset($_SESSION[DOU_ID]['article_selected']);
        
        $dou->create_admin_log($_LANG['weixin'] . ' - ' . $_LANG['weixin_media_edit'] . ': ' . $_POST['name']);
        $dou->dou_msg($_LANG['weixin_media_edit'] . $_LANG['success'], 'weixin.php?rec=media');
    } 

    // 素材删除
    elseif ($act == 'del') {
        // 验证并获取合法的ID
        $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'weixin.php?rec=media');
        
        $name = $dou->get_one("SELECT name FROM " . $dou->table('weixin_media') . " WHERE id = '$id'");
        
        if (isset($_POST['confirm'])) {
            $dou->create_admin_log($_LANG['mobile'] . ' - ' . $_LANG['weixin_media_del'] . ': ' . $name);
            $dou->delete('weixin_media', "id = '$id'", 'weixin.php?rec=media');
        } else {
            $_LANG['del_check'] = preg_replace('/d%/Ums', $name, $_LANG['del_check']);
            $dou->dou_msg($_LANG['del_check'], 'weixin.php?rec=media', '', '30', "weixin.php?rec=media&act=del&id=$id");
        }
    }
 
    // 关注后推送
    elseif ($act == 'subscribe') {
        // 验证并获取合法的ID
        $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'weixin.php?rec=media');
        $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
        
        $type = $dou->get_one("SELECT type FROM " . $dou->table('weixin_media') . " WHERE id = '$id'");
        
        if ($type != 'subscribe') {
            $dou->query("UPDATE " . $dou->table('weixin_media') . " SET type = 'common' WHERE type = 'subscribe'");
            $dou->query("UPDATE " . $dou->table('weixin_media') . " SET type = 'subscribe' WHERE id = '$id'");
            $dou->dou_header('weixin.php?rec=media&page=' . $page);
        }
    }
 
    // 添加文章
    elseif ($act == 'article_add') {
        // 验证并获取合法的ID
        $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
        
        // 是否第一次添加
        if(!isset($_SESSION[DOU_ID]['article_selected'])) $_SESSION[DOU_ID]['article_selected'] = array();
     
        // 最多只能添加3个
        if (count($_SESSION[DOU_ID]['article_selected']) < 3) {
            if(!in_array($id, $_SESSION[DOU_ID]['article_selected'])) $_SESSION[DOU_ID]['article_selected'][] = $id;
        }
        
        echo $weixin->article_selected_html();
    }
 
    // 删除文章
    elseif ($act == 'article_del') {
        // 验证并获取合法的ID
        $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
        
        $_SESSION[DOU_ID]['article_selected'] = array_merge(array_diff($_SESSION[DOU_ID]['article_selected'], array($id)));
        
        echo $weixin->article_selected_html();
    }
 
    // 文章列表.HTML
    elseif ($act == 'article_can_select') {
        // 验证并获取合法的ID
        $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
        
        echo $weixin->article_can_select_html($page);
    }
}

?>