<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
if (!defined('IN_DOUCO')) {
    die('Hacking attempt');
}
class Weixin extends Core {
    /**
     * +----------------------------------------------------------
     * 获取菜单列表
     * +----------------------------------------------------------
     */
    function get_menu_list($current_id = '', $parent_id = 0, $level = 0, &$menu_list = array()) {
        $data = $GLOBALS['dou']->fn_query("SELECT * FROM " . $GLOBALS['dou']->table('weixin_menu') . " ORDER BY sort ASC");
        foreach ((array) $data as $value) {
            if ($value['parent_id'] == $parent_id) {
                $value['mark'] = str_repeat('-', $level);
                $value['code'] = unserialize($value['code']);
                if (isset($value['code']['url'])) {
                    $value['value'] = $value['code']['url'];
                    $value['type'] = $GLOBALS['_LANG']['weixin_menu_type_url'];
                } else {
                    $value['value'] = $GLOBALS['dou']->get_one("SELECT name FROM " . $GLOBALS['dou']->table('weixin_media') . " WHERE id = " . $value['code']['key']);
                    $value['type'] = $GLOBALS['_LANG']['weixin_menu_type_media'];
                }
                $value['cur'] = $value['id'] == $current_id ? true : false;
                $menu_list[] = $value;
                $this->get_menu_list($current_id, $value['id'], $level + 1, $menu_list);
            }
        }
        return $menu_list;
    }
 
    /**
     * +----------------------------------------------------------
     * 获取菜单列表
     * +----------------------------------------------------------
     */
    function get_menu_weixin_data($parent_id = 0) {
        $row = $GLOBALS['dou']->fn_query("SELECT * FROM " . $GLOBALS['dou']->table('weixin_menu') . " WHERE parent_id = '$parent_id' ORDER BY sort ASC");
        foreach ((array) $row as $value) {
            $sub_button = $this->get_menu_weixin_data($value['id']);
            if ($sub_button) {
                $data['name'] = urlencode($value['name']);
                $data['sub_button'] = $this->get_menu_weixin_data($value['id']);
                $menu_list[] = $data;
            } else {
                $data = unserialize($value['code']);
                $data['name'] = urlencode($data['name']);
                $menu_list[] = $data;
            }
        }
        return $menu_list;
    }

    /**
     * +----------------------------------------------------------
     * 获取素材列表
     * +----------------------------------------------------------
     */
    function get_media_list($cur_id = '') {
        $sql = "SELECT * FROM " . $GLOBALS['dou']->table('weixin_media') . " ORDER BY id ASC";
        $query = $GLOBALS['dou']->query($sql);
        while ($row = $GLOBALS['dou']->fetch_array($query)) {
            $media_list[] = array (
                    "id" => $row['id'],
                    "name" => $row['name'],
                    "cur" => $row['id'] == $cur_id ? true : false
            );
        }

        return $media_list;
    }

    /**
     * +----------------------------------------------------------
     * 获取可选文章列表
     * +----------------------------------------------------------
     */
    function article_can_select_html($page = '1', $page_size = '8') {
        $sql = "SELECT id, title, image, add_time FROM " . $GLOBALS['dou']->table('article') . " WHERE image != '' ORDER BY sort ASC, id ASC";

        $record_count = $GLOBALS['dou']->num_rows($GLOBALS['dou']->query($sql));
        $page = (int)$page;
        $page_count = ceil($record_count / $page_size);

        $previous = $page > 1 ? $page - 1 : 1;
        $next = $page_count > $page ? $page + 1 : $page;
        $start = ($page - 1) * $page_size;

        $html = '<div class="articleList">';

        $sql = $sql . " LIMIT $start, $page_size";
        $query = $GLOBALS['dou']->query($sql);
        while ($row = $GLOBALS['dou']->fetch_array($query)) {
            $html .= '<div class="item">
                       <ul>
                        <li class="data"><a href="javascript:void(0)" onClick="dou_callback(' . "'weixin.php?rec=media&act=article_add', 'id', '" . $row['id'] . "', 'article_selected'" . ')">选择</a>' .  date("Y年m月d日", $row['add_time']) . '</li>
                        <li class="img"><img src="' . $GLOBALS['dou']->dou_file($row['image']) . '" /></li>
                        <li class="title" title="' . $row['title'] . '">' . $row['title'] . '</li>
                       </ul>
                      </div>';
        }

        $html .= '</div>';
        $html .= '<div class="pageBtn">
                   <a href="javascript:void(0)" onClick="dou_callback(' . "'weixin.php?rec=media&act=article_can_select', 'page', '" . $previous . "', 'article_can_select'" . ')">上一页</a> <a href="javascript:void(0)" onClick="dou_callback(' . "'weixin.php?rec=media&act=article_can_select', 'page', '" . $next . "', 'article_can_select'" . ')">下一页</a>
                  </div>';

        return $html;
    }

    /**
     * +----------------------------------------------------------
     * 获取已选文章列表
     * +----------------------------------------------------------
     */
    function article_selected_html() {
        if ($_SESSION[DOU_ID]['article_selected']) {
            // 格式化ID
            $id_list = implode(', ', $_SESSION[DOU_ID]['article_selected']);

            $html = '<div class="articleList">';

            $sql = "SELECT id, title, image, add_time FROM " . $GLOBALS['dou']->table('article') . " WHERE image != '' AND id IN (" . $id_list . ") ORDER BY sort ASC, id ASC";
            $query = $GLOBALS['dou']->query($sql);
            while ($row = $GLOBALS['dou']->fetch_array($query)) {
                $html .= '<div class="item">
                           <ul>
                            <li class="data"><a href="javascript:void(0)" onClick="dou_callback(' . "'weixin.php?rec=media&act=article_del', 'id', '" . $row['id'] . "', 'article_selected'" . ')">X</a>' .  date("Y年m月d日", $row['add_time']) . '</li>
                            <li class="img"><img src="' . $GLOBALS['dou']->dou_file($row['image']) . '" /></li>
                            <li class="title" title="' . $row['title'] . '">' . $row['title'] . '</li>
                           </ul>
                          </div>';
            }

            $html .= '</div>';

            return $html;
        }
    }

    /**
     * +----------------------------------------------------------
     * 获取已选文章标题
     * +----------------------------------------------------------
     */
    function article_selected($article_list_data) {
        if ($article_list_data) {
            // 格式化ID
            $id_list = implode(', ', $article_list_data);

            $sql = "SELECT id, title FROM " . $GLOBALS['dou']->table('article') . " WHERE id IN (" . $id_list . ") ORDER BY sort ASC, id ASC";
            $query = $GLOBALS['dou']->query($sql);
            while ($row = $GLOBALS['dou']->fetch_array($query)) {
                $article_list[] = array (
                        "id" => $row['id'],
                        "title" => $row['title'],
                        "url" => $GLOBALS['dou']->rewrite_url('article', $row['id'])
                );
            }

            return $article_list;
        }
    }
 
    /**
     * +----------------------------------------------------------
     * 公众号素材推送
     * +----------------------------------------------------------
     */
    function media_push_data($type, $key = '') {
        // 获取素材对应的文章列表
        if ($type == 'subscribe') {
            $where = " WHERE type = 'subscribe'";
        } elseif ($type == 'text') {
            $where = " WHERE name = '$key'";
        } else {
            $where = " WHERE id = '$key'";
        }
        $article_list = $GLOBALS['dou']->get_one("SELECT article_list FROM " . $GLOBALS['dou']->table('weixin_media') . $where);
        
        if ($article_list) {
            $article_list = unserialize($article_list); // 反序列化
            $id_list = implode(', ', $article_list); // 格式化ID

            $sql = "SELECT id, title, image FROM " . $GLOBALS['dou']->table('article') . " WHERE id IN (" . $id_list . ") ORDER BY sort ASC, id ASC";
            $query = $GLOBALS['dou']->query($sql);
            while ($row = $GLOBALS['dou']->fetch_array($query)) {
                $url = $GLOBALS['dou']->rewrite_url('article', $row['id']);
                $image = $GLOBALS['dou']->dou_file($row['image']);

                $push_data[] = array("Title"=>$row['title'], "Description"=>"", "PicUrl"=>$image, "Url" =>$url);
            }

            return $push_data;
        }
    }
} 

?>